<?php
/************************************************************************
 * M-XChange v0.2.1                                   Start: 10/10/2008 *
 * ================                             Last change: 10/10/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_yoomedia_tm.php                        *
 * -------------------------------------------------------------------- *
 * Short description : List Yoo!Media text mails                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auflisten von Yoo!Media Textmails                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software. You can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License.       *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!EXT_IS_ACTIVE('yoomedia')) {
	addFatalMessage(__FILE__, __LINE__, generateExtensionInactiveMessage('yoomedia'));
	return;
} elseif (!EXT_IS_ACTIVE('bonus')) {
	addFatalMessage(__FILE__, __LINE__, generateExtensionInactiveMessage('bonus'));
	return;
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

// Do actions here
if (isFormSent()) {
	// Prepare mail for delivery
	YOOMEDIA_PREPARE_MAIL_DELIVERY(REQUEST_POST_ARRAY());
	return;
} elseif (REQUEST_ISSET_POST(('sent'))) {
	// Sent mail
	YOOMEDIA_SEND_BONUS_MAIL(REQUEST_POST_ARRAY(), 'normal');
} elseif (REQUEST_ISSET_POST('remove')) {
	// Add mail to exclude list
	YOOMEDIA_EXCLUDE_MAIL(REQUEST_POST_ARRAY(), 'normal');
} elseif (REQUEST_ISSET_POST(('unlist'))) {
	// Remove mail from exclude list
	YOOMEDIA_UNLIST_MAIL(REQUEST_POST_ARRAY(), 'normal');
}

// Enougth queries left?
if (getConfig('yoomedia_requests_remain') == 0) {
	// Output message
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_YOOMEDIA_REQUESTS_DEPLETED'));

	// Abort here!
	return false;
} // END - if

// Get parsed array back
$result = YOOMEDIA_GET_PARSED_RESULT_TEXTMAILS();

// Sanity-check on result array
if ((!is_array($result)) || (count($result) == 0) || (!isset($result[0]['id']))) {
	// Invalid result
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_YOOMEDIA_INVALID_RESULT'));
	return false;
} elseif (count($result[0]) < 7) {
	// Error received so prepare error code
	$code = explode(" ", $result[0]['id']);
	$code = $code[0];
	$code = explode("<br />", $code);
	$code = $code[0];

	// Output message
	LOAD_TEMPLATE('admin_yoomedia_error', false, sprintf("{--ADMIN_YOOMEDIA_ERROR_%s--}", strtoupper(yoomediaTranslateError($code))));
	return false;
}

// Prepare all entries
$OUT = ''; $SW = 2;
foreach ($result as $entry) {
	// Translate some data
	$entry['pay']    = translateComma($entry['pay'], true, 5);
	$entry['remain'] = translateComma($entry['remain']);
	$entry['sw']     = $SW;

	// Check reload lock
	$reload = YOOMEDIA_CHECK_RELOAD($entry['id'], $entry['reload'], 'textmail');

	// Is this mail already sent?
	if ($reload !== false) {
		// Init countdown
		$countdown = 0;

		// Not manually locked?
		if ($reload > 0) {
			// Calculate countdown
			$countdown = $reload + ($entry['reload'] * 60*60) - time();

			// Countdown < 60 seconds and bigger zero?
			if (($countdown < 60) && ($countdown > 0)) {
				// Fix to one minute
				$countdown = 60;
			} // END - if

			// Add reload lock
			$entry['already'] = sprintf(getMessage('ADMIN_YOOMEDIA_TEXTMAIL_SEND_AGAIN'), createFancyTime($countdown));
		} else {
			// Never resentable unless manual removal
			$entry['already'] = getMessage('ADMIN_YOOMEDIA_TEXTMAIL_MANUALLY_LOCKED');
		}

		// Load row template for displaying
		$OUT .= LOAD_TEMPLATE('admin_list_yoomedia_tm_already', true, $entry);
	} else {
		// Load row template with buttons
		$OUT .= LOAD_TEMPLATE('admin_list_yoomedia_tm_row', true, $entry);
	}

	// Switch color
	$SW = 3 - $SW;
} // END - if

// Load main template
LOAD_TEMPLATE('admin_list_yoomedia_tm', false, $OUT);

//
?>
