<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/24/2003 *
 * ===============                              Last change: 06/30/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : frametester.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Test your website against frame killers          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Testet die Mitgliedsseite gegen Frame-Killer     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

$mode = 'guest';

if (REQUEST_ISSET_GET(('order'))) {
	// Order number placed, is he also logged in?
	if (IS_MEMBER()) {
		// Ok, test passed... :)
		$result = SQL_QUERY_ESC("SELECT subject, url FROM `{!_MYSQL_PREFIX!}_pool` WHERE `id`=%s AND sender=%s AND data_type='TEMP' LIMIT 1",
		array(bigintval(REQUEST_GET('order')), getUserId()), __FILE__, __LINE__);

		// Finally is the entry valid?
		if (SQL_NUMROWS($result) == 1) {
			// Load subject and URL (but forwhat do we need the subject line here???
			list($sub, $url) = SQL_FETCHROW($result);

			// This fixes a white page
			REQUEST_SET_POST('url', $url);

			// Mode is member
			$mode = 'member';
		} else {
			// Matching line not found!
			redirectToUrl('modules.php?module=index&amp;what=login');
		}

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// He is no longer logged in
		redirectToUrl('modules.php?module=index&amp;what=login');
	}
}

if ((REQUEST_ISSET_POST('url')) || (REQUEST_ISSET_GET('url')) || (REQUEST_ISSET_GET('frame'))) {
	// Default URL is ours
	$url = constant('URL');

	// Decode URL if set in GET parameters
	if (REQUEST_ISSET_GET('url'))  $url = decodeString(str_replace(' ', '+', compileUriCode(urldecode(REQUEST_GET('url')))));

	// Use URL from POST data if set
	if (REQUEST_ISSET_POST('url')) $url = REQUEST_POST('url');

	// Add missing element
	$frame = '';
	if (REQUEST_ISSET_GET('frame')) $frame = REQUEST_GET('frame');
	switch ($frame)
	{
		case '':
			switch ($mode)
			{
				case 'member':
					// Build frameset
					define('__ORDER_VALUE', bigintval(REQUEST_GET('order')));
					define('__URL_VALUE'  , DEREFERER($url));
					LOAD_TEMPLATE('member_order_frametester');
					break;

				case 'guest':
					define('__URL_VALUE'  , DEREFERER($url));
					LOAD_TEMPLATE('guest_frametester');
					break;
			}
			break;

				case 'test_top':
					LOAD_TEMPLATE('admin_settings_saved', false, '<div class="guest_done">{--GUEST_FRAMETESTER_TOP--}</span>');
					break;

				case 'back': // Back buttom
					LOAD_TEMPLATE('member_order_back', false, REQUEST_GET('order'));
					break;

				case 'send': // Send mail away
					LOAD_TEMPLATE('member_order_send', false, REQUEST_GET('order'));
					break;
	}
} else {
	// Go away...
	redirectToUrl('modules.php?module=login');
}
//
?>
